Loading...
Searching...
No Matches
Ogre::IntersectionSceneQuery Class Referenceabstract
Core » Scene

Separate SceneQuery class to query for pairs of objects which are possibly intersecting one another. More...

`#include <OgreSceneQuery.h>`

Inheritance diagram for Ogre::IntersectionSceneQuery:
[legend]

## Public Member Functions

| IntersectionSceneQuery (SceneManager *mgr)
virtual | ~IntersectionSceneQuery ()
void | clearResults (void)
| Clears the results of the last query execution.
virtual void | execute (IntersectionSceneQueryListener *listener)=0
| Executes the query and returns each match through a listener interface.
virtual IntersectionSceneQueryResult & | execute (void)
| Executes the query, returning the results back in one list.
virtual IntersectionSceneQueryResult & | getLastResults (void) const
| Gets the results of the last query that was run using this object, provided the query was executed using the collection-returning version of execute.
bool | queryResult (MovableObject *first, MovableObject *second) override
| Self-callback in order to deal with execute which returns collection.
bool | queryResult (MovableObject *movable, SceneQuery::WorldFragment *fragment) override
| Self-callback in order to deal with execute which returns collection.
Public Member Functions inherited from Ogre::SceneQuery
| SceneQuery (SceneManager *mgr)
| Standard constructor, should be called by SceneManager.
virtual | ~SceneQuery ()
virtual uint32 | getQueryMask (void) const
| Returns the current mask for this query.
virtual uint32 | getQueryTypeMask (void) const
| Returns the current mask for this query.
virtual void | setQueryMask (uint32 mask)
| Sets the mask for results of this query.
virtual void | setQueryTypeMask (uint32 mask)
| Sets the type mask for results of this query.
Public Member Functions inherited from Ogre::IntersectionSceneQueryListener
virtual | ~IntersectionSceneQueryListener ()

## Additional Inherited Members

Public Types inherited from Ogre::SceneQuery
typedef Ogre::WorldFragment | WorldFragment

## Detailed Description

Separate SceneQuery class to query for pairs of objects which are possibly intersecting one another.

This SceneQuery subclass considers the whole world and returns pairs of objects which are close enough to each other that they may be intersecting. Because of this slightly different focus, the return types and listener interface are different for this class.

## Constructor & Destructor Documentation

## IntersectionSceneQuery()

Ogre::IntersectionSceneQuery::IntersectionSceneQuery | ( | SceneManager * | mgr | ) |

## ~IntersectionSceneQuery()

virtual Ogre::IntersectionSceneQuery::~IntersectionSceneQuery | ( |  | ) |

virtual

## Member Function Documentation

## execute() [1/2]

virtual IntersectionSceneQueryResult & Ogre::IntersectionSceneQuery::execute | ( | void |  | ) |

virtual

Executes the query, returning the results back in one list.

This method executes the scene query as configured, gathers the results into one structure and returns a reference to that structure. These results will also persist in this query object until the next query is executed, or clearResults() is called. An more lightweight version of this method that returns results through a listener is also available.

## execute() [2/2]

virtual void Ogre::IntersectionSceneQuery::execute | ( | IntersectionSceneQueryListener * | listener | ) |

pure virtual

Executes the query and returns each match through a listener interface.

Note that this method does not store the results of the query internally so does not update the 'last result' value. This means that this version of execute is more lightweight and therefore more efficient than the version which returns the results as a collection.

Implemented in Ogre::BspIntersectionSceneQuery, Ogre::DefaultIntersectionSceneQuery, Ogre::OctreeIntersectionSceneQuery, and Ogre::PCZIntersectionSceneQuery.

## getLastResults()

virtual IntersectionSceneQueryResult & Ogre::IntersectionSceneQuery::getLastResults | ( | void |  | ) | const

virtual

Gets the results of the last query that was run using this object, provided the query was executed using the collection-returning version of execute.

## clearResults()

void Ogre::IntersectionSceneQuery::clearResults | ( | void |  | ) |

Clears the results of the last query execution.

You only need to call this if you specifically want to free up the memory used by this object to hold the last query results. This object clears the results itself when executing and when destroying itself.

## queryResult() [1/2]

bool Ogre::IntersectionSceneQuery::queryResult | ( | MovableObject * | first,
|  | MovableObject * | second )

override virtual

Self-callback in order to deal with execute which returns collection.

Implements Ogre::IntersectionSceneQueryListener.

## queryResult() [2/2]

bool Ogre::IntersectionSceneQuery::queryResult | ( | MovableObject * | movable,
|  | SceneQuery::WorldFragment * | fragment )

override virtual

Self-callback in order to deal with execute which returns collection.

Implements Ogre::IntersectionSceneQueryListener.

The documentation for this class was generated from the following file:

- OgreSceneQuery.h